<?php

$Columns = array('name', 'atname', 'attype', 'tot_chars', 'atrating', 'atwins', 'atgames');
$order_by = (isset($_GET['order'])) ? $_GET['order'] : 'atname';
if(!in_array($order_by, $Columns)) $order_by = 'atname';
$dir = (isset($_GET['dir'])) ? $_GET['dir'] : 'down';
$order_dir = ($dir == 'up') ? 'ASC' : 'DESC';
$dir = ($dir == 'down') ? 'up' : 'down';
$dir_img = ($dir == 'down') ? '<img src="imgs/inc/up.gif" alt="nahoru"/>' : '<img src="imgs/inc/down.gif" alt="dolu">';

function MakeLink($show, $sort)
{
  global $dir, $dir_img;
  
  if(isset($_GET['order']) and $_GET['order'] == $sort) $arrow = $dir_img;
  else $arrow = '';
  return($arrow.'<a href="?page=arena&amp;order='.$sort.'&amp;dir='.$dir.'">'.$show.'</a>');
}

$db->select_db($Config['Mangos']['RealmList'][$_COOKIE['RealmIndex']]['DatabaseCharacters']);
$count = $db->query('SELECT COUNT(*) FROM arena_team')->fetch_row();
$all_record = $count[0];
echo('<h3 class="PageTitle">Arénové týmy :</h3>
Celkem týmů : <strong>'.$all_record.'</strong>
  <table class="BaseTable">
    <tr>
      <th>'.MakeLink('Tým', 'atname').'</th>
      <th>Kapitán</th>
      <th>'.MakeLink('Typ', 'attype').'</th>
      <th>'.MakeLink('Členů', 'tot_chars').'</th>
      <th>'.MakeLink('Rating', 'atrating').'</th>
      <th>'.MakeLink('Her vyhráno', 'atwins').'</th>
      <th>'.MakeLink('Her hráno', 'atgames').'</th>
    </tr>'); 
$query = $db->query('SELECT arena_team.arenateamid AS atid, arena_team.name AS atname, arena_team.captainguid AS lguid, arena_team.type AS attype, (SELECT name FROM `characters` WHERE guid = lguid) AS l_name, (SELECT COUNT(*) FROM arena_team_member WHERE arenateamid = atid) AS tot_chars, rating AS atrating, games as atgames, wins as atwins FROM arena_team, arena_team_stats WHERE arena_team.arenateamid = arena_team_stats.arenateamid ORDER BY '.$order_by.' '.$order_dir);
while($row = $query->fetch_assoc())
{
  echo('<tr>
        <td align="center">'.$row['atname'].'</td>
        <td align="center">'.$row['l_name'].'</td>
        <td align="center">'.$row['attype'].'</td>
        <td align="center">'.$row['tot_chars'].'</td>
        <td align="center">'.$row['atrating'].'</td>
        <td align="center">'.$row['atwins'].'</td>
        <td align="center">'.$row['atgames'].'</td>
      </tr>');
}
echo('</table>');

?>
