<?php

$order_by = (isset($_GET['order'])) ? $db->real_escape_string($_GET['order']) : 'name';
$dir = (isset($_GET['dir'])) ? $db->real_escape_string($_GET['dir']) : 'down';
$order_dir = ($dir == 'up') ? 'ASC' :'DESC';
$dir = ($dir == 'down') ? 'up' : 'down';
$dir_img = ($dir == 'down') ? '<img src="imgs/inc/up.gif" alt="vzestupně" />' : '<img src="imgs/inc/down.gif" alt="sestupně"/>';

function MakeLink($show, $sort)
{
  global $dir, $dir_img;
  if(isset($_GET['order']) and $_GET['order'] == $sort)
  {
    $arrow = $dir_img;
  }
  else
  {
    $arrow = '';
  }
  return($arrow.'<a href="?page=online&amp;order='.$sort.'&amp;dir='.$dir.'">'.$show.'</a>');
}

echo('<h3 class="PageTitle">Online hráči</h3>');
echo('<div style="text-align: center">Celkem '.$server->MangosOnline($_COOKIE['RealmIndex']).' hráčů.</div>'.
'<table class="BaseTable">
  <tr>
    <th align="center">Frakce</th>
    <th align="center">'.MakeLink('Nick', 'name').'</th>
    <th align="center">'.MakeLink('Rasa', 'race').'</th>
    <th align="center">'.MakeLink('Class', 'class').'</th>
    <th align="center">'.MakeLink('Lvl', 'level').'</th>
    <th align="center">'.MakeLink('Mapa', 'map').'</th>
    <th align="center">'.MakeLink('Honory', 'highest_rank').'<br />'.
    MakeLink('Aréna body', 'arena_points').'</th></tr>');

$db->select_db($Config['Mangos']['RealmList'][$_COOKIE['RealmIndex']]['DatabaseCharacters']);
$sql = $db->query('SELECT guid, name, race, class, zone, map, '.
  'CAST( SUBSTRING_INDEX(SUBSTRING_INDEX(`data`, " ", '.$Config['Mangos']['CharacterDataOffset']['HonorPoints'].'+1), " ", -1) AS UNSIGNED) AS highest_rank, '.
  'CAST( SUBSTRING_INDEX(SUBSTRING_INDEX(`data`, " ", '.$Config['Mangos']['CharacterDataOffset']['Level'].' + 1), " ", -1) AS UNSIGNED) AS level, '.
  'CAST( SUBSTRING_INDEX(SUBSTRING_INDEX(`data`, " ", '.$Config['Mangos']['CharacterDataOffset']['ArenaPoints'].' + 1), " ", -1) AS UNSIGNED) AS arena_points, '.
  'mid(lpad( hex( CAST(substring_index(substring_index(data, " ", '.$Config['Mangos']['CharacterDataOffset']['Gender'].' + 1), " ", -1) as unsigned) ), 8, 0), 4, 1) AS gender '.
  'FROM `characters` WHERE `online`= 1 ORDER BY `'.$order_by.'` '.$order_dir);
while($row = $sql->fetch_assoc())
{
  $aliance = array(1, 3, 4, 7, 11);
  $frakce = (in_array($row['race'], $aliance)) ? '<img src="imgs/inc/a.gif" alt="aliance"/>' : '<img src="imgs/inc/h.gif" alt="horda" />';
  $gender = ($row['gender'] == 0) ? '0' : '1';
  echo('<tr>
      <td align="center">'.$frakce.'</td>
      <td align="center">'.$row['name'].'</td>
      <td align="center"><img src="imgs/icons/'.$row['race'].'-'.$gender.'.gif" alt="rasa" /></td>
      <td align="center"><img src="imgs/icons/'.$row['class'].'.gif" alt="třída" /></td>
      <td align="center">'.$row['level'].'</td>
      <td align="center">'.$server->MapName($row['map']).'<br />('.$server->ZoneName($row['zone']).')</td>
      <td align="center">'.$row['highest_rank'].'<br />'.$row['arena_points'].'</td></tr>');
}
echo('</table>');

?>
